// SHA1Hash: d1fd6c78481c11eec5333cc1e2e91b82510e0965
/*
* Copyright (C) 2014 Apple Inc. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
* 1.  Redistributions of source code must retain the above copyright
*     notice, this list of conditions and the following disclaimer. 
* 2.  Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in the
*     documentation and/or other materials provided with the distribution. 
*
* THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS CONTRIBUTORS BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
* THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

* Autogenerated from /builddir/build/BUILD/webkitgtk-2.20.0/Source/JavaScriptCore/bytecode/BytecodeList.json, do not modify.
*/

#pragma once

#include "Instruction.h"

namespace JSC {

struct OpCreateThis {
public:
    Opcode& opcode() { return *reinterpret_cast<Opcode*>(&m_opcode); }
    const Opcode& opcode() const { return *reinterpret_cast<const Opcode*>(&m_opcode); }
    int& dst() { return *reinterpret_cast<int*>(&m_dst); }
    const int& dst() const { return *reinterpret_cast<const int*>(&m_dst); }
    int& callee() { return *reinterpret_cast<int*>(&m_callee); }
    const int& callee() const { return *reinterpret_cast<const int*>(&m_callee); }
    int& inlineCapacity() { return *reinterpret_cast<int*>(&m_inlineCapacity); }
    const int& inlineCapacity() const { return *reinterpret_cast<const int*>(&m_inlineCapacity); }
    WriteBarrier<JSCell>& cachedCallee() { return *reinterpret_cast<WriteBarrier<JSCell>*>(&m_cachedCallee); }
    const WriteBarrier<JSCell>& cachedCallee() const { return *reinterpret_cast<const WriteBarrier<JSCell>*>(&m_cachedCallee); }

private:
    friend class LLIntOffsetsExtractor;

    std::aligned_storage<sizeof(Opcode), sizeof(Instruction)>::type m_opcode;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_dst;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_callee;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_inlineCapacity;
    std::aligned_storage<sizeof(WriteBarrier<JSCell>), sizeof(Instruction)>::type m_cachedCallee;
};

struct OpOverridesHasInstance {
public:
    Opcode& opcode() { return *reinterpret_cast<Opcode*>(&m_opcode); }
    const Opcode& opcode() const { return *reinterpret_cast<const Opcode*>(&m_opcode); }
    int& dst() { return *reinterpret_cast<int*>(&m_dst); }
    const int& dst() const { return *reinterpret_cast<const int*>(&m_dst); }
    int& constructor() { return *reinterpret_cast<int*>(&m_constructor); }
    const int& constructor() const { return *reinterpret_cast<const int*>(&m_constructor); }
    int& hasInstanceValue() { return *reinterpret_cast<int*>(&m_hasInstanceValue); }
    const int& hasInstanceValue() const { return *reinterpret_cast<const int*>(&m_hasInstanceValue); }

private:
    friend class LLIntOffsetsExtractor;

    std::aligned_storage<sizeof(Opcode), sizeof(Instruction)>::type m_opcode;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_dst;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_constructor;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_hasInstanceValue;
};

struct OpInstanceof {
public:
    Opcode& opcode() { return *reinterpret_cast<Opcode*>(&m_opcode); }
    const Opcode& opcode() const { return *reinterpret_cast<const Opcode*>(&m_opcode); }
    int& dst() { return *reinterpret_cast<int*>(&m_dst); }
    const int& dst() const { return *reinterpret_cast<const int*>(&m_dst); }
    int& value() { return *reinterpret_cast<int*>(&m_value); }
    const int& value() const { return *reinterpret_cast<const int*>(&m_value); }
    int& prototype() { return *reinterpret_cast<int*>(&m_prototype); }
    const int& prototype() const { return *reinterpret_cast<const int*>(&m_prototype); }

private:
    friend class LLIntOffsetsExtractor;

    std::aligned_storage<sizeof(Opcode), sizeof(Instruction)>::type m_opcode;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_dst;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_value;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_prototype;
};

struct OpInstanceofCustom {
public:
    Opcode& opcode() { return *reinterpret_cast<Opcode*>(&m_opcode); }
    const Opcode& opcode() const { return *reinterpret_cast<const Opcode*>(&m_opcode); }
    int& dst() { return *reinterpret_cast<int*>(&m_dst); }
    const int& dst() const { return *reinterpret_cast<const int*>(&m_dst); }
    int& value() { return *reinterpret_cast<int*>(&m_value); }
    const int& value() const { return *reinterpret_cast<const int*>(&m_value); }
    int& constructor() { return *reinterpret_cast<int*>(&m_constructor); }
    const int& constructor() const { return *reinterpret_cast<const int*>(&m_constructor); }
    int& hasInstanceValue() { return *reinterpret_cast<int*>(&m_hasInstanceValue); }
    const int& hasInstanceValue() const { return *reinterpret_cast<const int*>(&m_hasInstanceValue); }

private:
    friend class LLIntOffsetsExtractor;

    std::aligned_storage<sizeof(Opcode), sizeof(Instruction)>::type m_opcode;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_dst;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_value;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_constructor;
    std::aligned_storage<sizeof(int), sizeof(Instruction)>::type m_hasInstanceValue;
};

} // namespace JSC 
